var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx } from "react/jsx-runtime";
import Notification from 'rc-notification';
import ToastContainer from "./ToastContainer";
import "./style/toastOnTarget.css";
var maxCount = 1;
var defaultDuration = 1.5; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore

var toastOnTarget = function toastOnTarget(getContainer, prefix) {
  if (prefix === void 0) {
    prefix = 'target';
  }

  var notification;
  Notification.newInstance({
    prefixCls: 'dmc-toast-on-target',
    maxCount: maxCount,
    getContainer: getContainer
  }, function (n) {
    notification = n;
  });
  var i = 0; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore

  var toastApi = {
    notification: notification
  };
  ['success', 'warning', 'info', 'error'].forEach(function (key) {
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    toastApi[key] = function (message) {
      var props = typeof message === 'string' ? {
        message: message
      } : message;

      var duration = props.duration,
          others = __rest(props, ["duration"]);

      var id = "toast-" + prefix + "-" + ++i;

      var onClose = function onClose() {
        return notification.removeNotice(id);
      };

      notification.notice({
        content: _jsx(ToastContainer, __assign({
          type: key
        }, others, {
          onClose: onClose
        }), void 0),
        key: id,
        closeIcon: false,
        duration: duration !== undefined ? duration : defaultDuration,
        closable: false
      });
      return {
        id: id
      };
    };
  });
  return toastApi;
};

export default toastOnTarget;

